#include <stdio.h>

#include "cmdline.h"

unsigned char old_renderline = 0;
unsigned char private_cmap = 0;
unsigned char use_marat = 1;
unsigned char use_repulse = 0;
unsigned char enable_freqsweep = 0;
unsigned char look_ugly = 0;
unsigned char dump_audio = 0;

void usage(void)
{
    printf("Usage: stanknes <rom image>\n\n");
}

char *parse_args(int argc, char **argv)
{
    int i;
    char *rom_name;
    
    for (i = 1; i < argc; i++)
    {
	if (*argv[i] == '-')
	{
	    if (!strcmp(argv[i], "-old"))
		old_renderline = 1;
	    else if (!strcmp(argv[i], "-private"))
		private_cmap = 1;
	    else if (!strcmp(argv[i], "-marat"))
	    {
		use_marat = 1;
		use_repulse = 0;
	    }
	    else if (!strcmp(argv[i], "-repulse"))
	    {
		use_marat = 0;
		use_repulse = 1;
	    }
	    else if (!strcmp(argv[i], "-sweep"))
	    {
		enable_freqsweep = 1;
	    }
	    else if (!strcmp(argv[i], "-skipframes"))
	    {
		look_ugly = 1;
	    }
	    else if (!strcmp(argv[i], "-dump"))
	    {
		dump_audio = 1;
	    }
	}
	else
	    rom_name = argv[i];
    }
    return rom_name;
}
