#include <stdio.h>

unsigned long expandleft(unsigned char i)
{
    unsigned long ret = 0;

    if (i & 0x10)
	ret |= 0xFF000000;
    if (i & 0x20)
	ret |= 0x00FF0000;
    if (i & 0x40)
	ret |= 0x0000FF00;
    if (i & 0x80)
	ret |= 0x000000FF;
    return ret;
}

unsigned long expandright(unsigned char i)
{
    unsigned long ret = 0;

    if (i & 0x1)
	ret |= 0xFF000000;
    if (i & 0x2)
	ret |= 0x00FF0000;
    if (i & 0x4)
	ret |= 0x0000FF00;
    if (i & 0x8)
	ret |= 0x000000FF;
    return ret;
}

int main(void)
{
    FILE *fp;
    unsigned char i;
    
    fp = fopen("luts.h", "wt");

    fprintf(fp, "#ifndef LUTS_H\n#define LUTS_H\n\n");
    fprintf(fp, "unsigned long unpacktbl[256][2]\n\n");
    fprintf(fp, "#endif\n");
    fclose(fp);

    fp = fopen("luts.c", "wt");

    fprintf(fp, "#include \"luts.h\"\n\n");
    fprintf(fp, "unsigned long unpacktbl[256][2]\n{\n");
    
    i = 0;
    do
    {
	fprintf(fp,"\t{0x%08lx, 0x%08lx},\n", expandleft(i), expandright(i));
	i++;
    } while (i);
    fprintf(fp, "}\n");
    fclose(fp);
}
