        CHR_L = $200
        CHR_H = $201                ;chr address
        LINES = $202
        CURRENT = $203
        XSCROLL = $204
        SCROLL8 = $205
        STAGE = $206
        BLAH = $222

        SINOFF = 0
        ACC = 1
        SPEED = 2
        LINEBASE = $300

green:
        lda #$00                ;screen off
        sta $2000
        sta $2001

        jsr setup               ;prepare vram, etc

     ;   lda #(greennmi and $ff) ;set nmi vector
     ;   sta $07fa
     ;   lda #(greennmi>>8)
     ;   sta $07fb

        lda #$00                ;setup vars
        sta CHR_H
        sta CHR_L
        sta SCROLL8
        sta STAGE
        lda #16
        sta XSCROLL

        lda $2002
-       lda $2002
        bpl -

vblank:
        jsr drawstuff
        jsr dumpchr     ;copy CHR
        jsr drawstuff
        jsr dumpchr     ;copy CHR

        lda #$00        ;set scroll
        sta $2006
        sta $2006
        lda XSCROLL
        sta $2005
        sta $2005

        lda #%00000000  ;CHR set 0
        sta $2000
        lda #%00001010  ;screen on
        sta $2001

        ldy #$06        ;delay 64 lines
        ldx #$98
-       dex
        bne -
        dey
        bne -

        lda #%00010000  ;CHR set 1
        sta $2000

        jsr drawstuff

        ldy #$04        ;more delay
        ldx #$90
-       dex
        bne -
        dey
        bne -

        lda #$00        ;screen off
        sta $2001

        jsr dumpchr     ;copy CHR
        jsr seq

-       lda $2002
        bpl -

        jmp vblank


YTMP = $100
BITPOS = $101
ACCTMP = $102
SPEEDTMP = $103
drawstuff:
        lda SCROLL8     ;need to draw anything?
        bpl +
        jsr fakeclear            ;still eat up the same amount of cycles,
        lda LINES                ;whether we are really drawing or not
        sta CURRENT
--      ldx #$61
-       dex
        bne -
        dec CURRENT
        bne --
        rts
+
       jsr clear                ;clear ram 00-7f
       lda LINES
       asl
       asl                      ;loop *LINES:
--     clc
       sbc #3
       sta CURRENT
       tay
        lda #$80
        sta BITPOS
        ldx LINEBASE+SINOFF,y
        lda LINEBASE+ACC,y
        sta ACCTMP
        lda LINEBASE+SPEED,y
        sta SPEEDTMP
-       clc
        lda ACCTMP
        adc SPEEDTMP
        sta ACCTMP
        bcc +
        inx
+       ldy SINE,x
        lda BITPOS
        ora $00,y
        sta $00,y
        lda BITPOS
        ora $01,y
        sta $01,y
        lsr BITPOS
        bcc -
        ldy CURRENT
        lda ACCTMP
        sta LINEBASE+ACC,y
        txa
        sta LINEBASE+SINOFF,y
        tya
        bne --
        rts

COUNT = $100
dumpchr:                        ;dump ram $00-7f into CHR and clear it
        lda SCROLL8
        bmi +
        sec
        sbc #8
        sta SCROLL8

        lda CHR_L
        eor #$80
        sta CHR_L
        bne +
        inc CHR_H
+
        ldx #0
        lda #8
        sta COUNT
        lda CHR_H
        and #$0f
        sta $2006
        sta CHR_H
        ldy CHR_L
        clc
        jsr dc0

        lda #8
        sta COUNT
        lda CHR_H
        ora #$10
        sta $2006
        ldy CHR_L
        clc
        jmp dc0

dc1     sty $2005
dc0     sty $2006
        lda $00,x
        sta $2007
        lda $01,x
        sta $2007
        lda $02,x
        sta $2007
        lda $03,x
        sta $2007
        lda $04,x
        sta $2007
        lda $05,x
        sta $2007
        lda $06,x
        sta $2007
        lda $07,x
        sta $2007
        txa
        adc #8
        tax
        tya
        adc #$10
        tay
        dec COUNT
        bne dc1
        rts
clear
        ldx #$0f
        lda #0
-       sta $00,x
        sta $10,x
        sta $20,x
        sta $30,x
        sta $40,x
        sta $50,x
        sta $60,x
        sta $70,x
        dex
        bpl -
        rts
fakeclear               ;(eats up same # of cycles)
        ldx #$0f
        lda #0
-       lda $00,x
        lda $10,x
        lda $20,x
        lda $30,x
        lda $40,x
        lda $50,x
        lda $60,x
        lda $70,x
        dex
        bpl -
        rts
setup:
        lda #$00                ;inc*1
        sta $2000
        sta $2006
        sta $2006
        ldy #$10                ;clear CHR
        tax
-       sta $2007
        sta $2007
        dex
        bne -
        dey
        bne -

        lda #$04                ;inc*32
        sta $2000
        lda #$00                ;$0=tile#
        sta $00
        sta $01                 ;$1=vram offset

-       lda #$20                ;fill top half of nametable 0
        sta $2006                       ;0 8 ..
        lda $01                         ;1 9
        sta $2006                       ;2 A
        jsr st0                         ;3 B
        jsr st0                         ;..etc

        inc $01
        clc
        lda $00
        adc #$08
        sta $00
        bne -

        ldx #4
        lda #$00                ;inc*1
        sta $2000
        lda #$3f                ;set palette
        sta $2006
        lda #$00
        sta $2006
-       lda #$09  ;0
        sta $2007
        lda #$29  ;1
        sta $2007
        lda #$29  ;2
        sta $2007
        lda #$29  ;3
        sta $2007
        dex
        bne -

        lda #$20 : sta LINEBASE+SPEED
        sta LINEBASE+SPEED+4
        sta LINEBASE+SPEED+8
        sta LINEBASE+SPEED+12
        lda #$00 : sta LINEBASE+SINOFF
        sta LINEBASE+SINOFF+4
        sta LINEBASE+SINOFF+8
        sta LINEBASE+SINOFF+12
        lda #4
        sta LINES
        rts
st0
        ldy #8          ;half stripe
        ldx $00
-       stx $2007
        inx
        dey
        bne -
        rts
seq
        ldx STAGE
        bne _1
                lda LINEBASE+SINOFF                     ;wait for 1 period
                bne +
                lda #$30 : sta LINEBASE+SPEED+4         ;start line 2
                inc STAGE
+               jmp x8
_1      dex
        bne _2
                lda LINEBASE+SINOFF                     ;wait 1 period
                bne +
                sta LINEBASE+SINOFF+8                   ;start line 3
                lda #$40 : sta LINEBASE+SPEED+8
                inc STAGE
+               jmp x8
_2      dex
        bne _3
                lda LINEBASE+SINOFF                     ;wait 1 period
                bne +
                sta LINEBASE+SINOFF+12                  ;start line 4
                lda #$50 : sta LINEBASE+SPEED+12
                inc STAGE
+               jmp x8
_3      dex
        bne _4
                lda LINEBASE+SINOFF                     ;wait 1 period
                bne +
                inc STAGE                               ;increase speed
+               jmp x8
_4      dex
        bne _5
                lda LINEBASE+SINOFF                     ;wait 1 period
                cmp #$ff
                bcc +
                inc STAGE
+               jmp x16
_5      dex
        bne _6
                lda LINEBASE+SINOFF                     ;wait 1 period
                cmp #$ff
                bcc +
                lda XSCROLL
                sbc #8
                sta XSCROLL
                inc STAGE
+               jmp x16
_6      dex
        bne _7
                lda LINEBASE+SINOFF                     ;wait for lines
                cmp #$80                                ;to be evenly spread
                bcc +
                inc STAGE
                lda #$04
                sta LINEBASE+SPEED
                sta LINEBASE+SPEED+4
                sta LINEBASE+SPEED+8
                sta LINEBASE+SPEED+12
                lda #$60
                sta BLAH
+               jmp x24
_7      dex
        bne _8
                inc BLAH
                bpl +
                inc STAGE
+               jmp x24
_8      dex
        bne _9
                lda BLAH
                adc #$60
                sta BLAH
                bcc +
                inc LINEBASE+SPEED
                inc LINEBASE+SPEED+4
                inc LINEBASE+SPEED+8
                inc LINEBASE+SPEED+12
                bne +
                inc STAGE
                dec LINEBASE+SPEED
                dec LINEBASE+SPEED+4
                dec LINEBASE+SPEED+8
                dec LINEBASE+SPEED+12
+               jmp x24
_9
x24
        ldx #24
        jmp +
x16
        ldx #16
        jmp +
x8
        ldx #8
+       clc
        txa
        adc XSCROLL
        sta XSCROLL
        clc
        txa
        adc SCROLL8
        sta SCROLL8
        rts
