#ifndef MEMMAP_H
#define MEMMAP_H

#ifndef ROM_H
#include "rom.h"
#endif

#include "M6502.h"

typedef struct
{
    void (*InitMapper)(rominfo *ri);
    unsigned char (*Read_Mapper)(unsigned long addr);
    void (*Write_Mapper)(unsigned long addr, unsigned char v);
    unsigned char (*Read_CHR)(unsigned long addr);
    void (*Write_CHR)(unsigned long addr, unsigned char v);
    void (*CHR_Latch)(unsigned char bank, unsigned char tile);
    void (*Scanline_Hook)(void);
    int (*Check_IRQ)(void);
    void (*Vblank_Hook)(void);    
} mapper;

extern mapper *cur_mapper;
extern unsigned char *ram;
extern unsigned char *sram;
extern unsigned char *nametable[4];
extern unsigned char *attribtable[4];
extern unsigned char *palram;
extern unsigned char *sprpal;
extern unsigned char *vrom[8];

void InitMemmap(rominfo *ri);
unsigned char Read_CPU(unsigned long addr);
unsigned char Read_PPU(unsigned long addr);
unsigned char Read_Register(unsigned long addr);
void Write_Register(unsigned long addr, unsigned char value);
void Write_CPU(unsigned long addr, unsigned char value);
void Write_PPU(unsigned long addr, unsigned char value);
void MM_Mirror_One(unsigned char *nt);
void MM_Mirror_Vert(unsigned char *nt1, unsigned char *nt2);
void MM_Mirror_Horiz(unsigned char *nt1, unsigned char *nt2);
#endif
