#define PULSE_INTERNAL

#include "channel.h"
#include "nespulse.h"

unsigned char duty[] = { 2, 4, 8, 12 };

pulse_data pulse1_data;

void Set_Pulse_Counter(pulse_data *d, unsigned char count)
{
    d->countdown = count;
}

void Update_Pulse_Counter(struct channel *c)
{
    c->phaseacc += (1.7897725 / 60);
    
    if ((c->data->countdown) && (apu_control & c->control_mask))
	c->data->countdown--;
}

void Update_NES_Pulse(struct channel *c)
{
    unsigned char b;
    double freq = (double)c->regs[2] + (double)(c->regs[3] & 3) * 256;

    c->phaseacc += freq;

    c->data->count++;
    c->data->count &= 0xF;

    if (c->data->count < duty[regs[0] >> 6])
	b = 0xFF;
    else
	b = 0;

    if ((c->data->countdown) && (apu_control & c->control_mask))
    {
	c->level = b & (c->regs[0] & 0xF);
    }
    else
	c->level = 0;
}
