#include <stdio.h>
#include <unistd.h>
#include "cmdline.h"
#include "osssound.h"
#include "n6502.h"
#include "apu.h"

extern CONTEXTM6502 *n6502thingy;

#define SAMPLERATE         44100
#define BUFLEN             (SAMPLERATE / 60)
#define INPUTCLOCK         ((double)1789772.5)
#define INCVAL             ((double)INPUTCLOCK / (double)SAMPLERATE)

int numevents = 0;

typedef struct
{
    unsigned long timestamp;
    unsigned short addr;
    unsigned char value;
} event;

unsigned char countfunc[32] =
{
    5, 127, 10, 1, 20, 2, 40, 3, 80, 4, 30, 5, 7, 6, 13, 7,
    6, 8, 12, 9, 24, 10, 48, 11, 96, 12, 36, 13, 8, 14, 16, 15
};

event events[100];
extern unsigned long framecount;

unsigned char mixbuf[735];

void APU_Init(void)
{
    memset(pulse1_buf, 0, 735);

    if (pcm_fd)
	write(pcm_fd, pulse1_buf, 735);
}

unsigned char Read_APU_Register(unsigned short addr)
{
    printf("APU read from $%x\n",addr);
    return 0;
}

void Write_APU_Register(unsigned short addr, unsigned char value)
{
    events[numevents].timestamp = m6502zpGetElapsedTicks(0);
    events[numevents].addr = addr;
    events[numevents].value = value;
    numevents++;
}

#define PULSE1     1
#define PULSE2     2
#define TRI        4
#define NOISE      8
#define PCM       16

int ptr = 0;

unsigned char apu_status = 0;
unsigned char apu_control = 0;

void APU_Update(void)
{
    event *ev = events;
    int cycle = 41;

    ptr = 0;

    events[numevents].timestamp = 0xFFFFFFFF;

    while (ptr < 735)
    {
	while (ev->timestamp < 0xFFFFFFFF)
	{
	    if (ev->timestamp == -1)
		printf("Hmm, why are we processing the list terminator?\n");
	    
	    switch (ev->addr)
	    {
	    case 0x4000:
		break;
	    case 0x4001:
		break;
	    case 0x4002:
		break;
	    case 0x4003:
		break;
	    case 0x4015:
		apu_control = ev->value;
		break;
	    }
	    ev++;
	}

	ptr++;
    }

    if (pcm_fd)
	write(pcm_fd, mixbuf, 735);
    
    numevents = 0;
}
