#ifndef NEWPPU_H
#define NEWPPU_H

void Init_PPU();
unsigned char Read_PPU_Register(unsigned short addr);
void Write_PPU_Register(unsigned short addr, unsigned char value);
void PPU_End_Vblank();
void PPU_NewRenderline(unsigned char line);
void PPU_OldRenderline(unsigned char line);
void PPU_Start_Vblank();
unsigned char PPU_Check_NMI();

#define FRAMETIME 16667

#define CON1_NMI        0x80
#define CON1_SPRSIZE    0x20
#define CON1_BPAT       0x10
#define CON1_SPAT       0x08
#define CON1_PPUINC     0x04
#define CON1_NTMASK     0x03

#define CON2_BGMASK     0xE0
#define CON2_BGSHIFT    5
#define CON2_SDRAW      0x10
#define CON2_BDRAW      0x08
#define CON2_SCLIP      0x04
#define CON2_BCLIP      0x02
#define CON2_COLOR      0x01

#define STAT_VBLANK     0x80
#define STAT_HIT        0x40
#define STAT_SCOUNT     0x20
#define STAT_WP         0x10

#endif
