#ifndef PPU_H
#define PPU_H

unsigned char Read_PPU_Register(unsigned short addr);
void Write_PPU_Register(unsigned short addr, unsigned char value);
void PPU_End_Vblank();
unsigned char PPU_Check_NMI();
void PPU_Drawpal();
void PPU_NewRenderline(unsigned char line);
void PPU_OldRenderline(unsigned char line);
void PPU_Start_Vblank();
extern unsigned int debugdirtyflags;

#define FRAMETIME 16667

#define CON1_NMI        0x80
#define CON1_SPRSIZE    0x20
#define CON1_BPAT       0x10
#define CON1_SPAT       0x08
#define CON1_PPUINC     0x04
#define CON1_NTMASK     0x03

#define CON2_BGMASK     0xE0
#define CON2_BGSHIFT    5
#define CON2_SDRAW      0x10
#define CON2_BDRAW      0x08
#define CON2_SCLIP      0x04
#define CON2_BCLIP      0x02
#define CON2_COLOR      0x01

#define STAT_VBLANK     0x80
#define STAT_HIT        0x40
#define STAT_SCOUNT     0x20
#define STAT_WP         0x10

#define DIRTY_PAT0      0x1
#define DIRTY_PAT1      0x2
#define DIRTY_PAL0      0x4
#define DIRTY_PAL1      0x8
#define DIRTY_NT0       0x10
#define DIRTY_NT1       0x20
#define DIRTY_NT2       0x40
#define DIRTY_NT3       0x80
#define DIRTY_AT0       0x100
#define DIRTY_AT1       0x200
#define DIRTY_AT2       0x400
#define DIRTY_AT3       0x800


#define REDRAW_PAT0     0xF
#define REDRAW_PAT0_0   0x1
#define REDRAW_PAT0_1   0x2
#define REDRAW_PAT0_2   0x4
#define REDRAW_PAT0_3   0x8

#define REDRAW_PAT1     0xF0
#define REDRAW_PAT1_0   0x10
#define REDRAW_PAT1_1   0x20
#define REDRAW_PAT1_2   0x40
#define REDRAW_PAT1_3   0x80

#define REDRAW_NT       0xF00

#define REDRAW_NT0      0x100
#define REDRAW_NT1      0x200
#define REDRAW_NT2      0x400
#define REDRAW_NT3      0x800

#define REDRAW_AT0      0x111
#define REDRAW_AT1      0x222
#define REDRAW_AT2      0x444
#define REDRAW_AT3      0x888

#define REDRAW_PAL0     0xFFF
#define REDRAW_PAL1     0

#endif
