#include <stdio.h>

#include <X11/X.h>
#include <X11/Xlib.h>

#include "xlibgfx.h"
#include "p8.h"
#include "pal.h"
#include "cmdline.h"

void P8_SetPallete(void)
{
    XColor col;
    int i;
    
/*    if (private_cmap)
      {*/
	printf("Allocating private colormap...\n");
	XCreateColormap(xdisp, xwin, xvisual, AllocAll);
/*    }
    else
    {
	XCreateColormap(xdisp, xwin, xvisual, AllocNone);
	if (!XAllocColorCells(xdisp, xcmap, 0, 0, 0, xpix, 64))
	{
	    printf("Could not allocate all colors, try -private.\n");
	    exit(0);
	}
	else
	{*/
	    for (i = 0; i < 64; i++)
	    {
		col.flags = DoRed | DoGreen | DoBlue;
		col.red = nes_pal[i].r;
		col.green = nes_pal[i].g;
		col.blue = nes_pal[i].b;
		col.red += col.red << 8;
		col.green += col.green << 8;
		col.blue += col.blue << 8;
		col.pixel = i;
		XStoreColor(xdisp, xcmap, &col);
	    }
/*	}
	}*/
}

void P8_InitLookups(void)
{
    printf("Allocating colors...\n");
    P8_SetPallete();
}

void P8_Expandline(unsigned char line, unsigned char *data)
{
    memcpy((unsigned char *)framebuffer + (line << 8), data, 256);
}

void P8_Clearline(unsigned char line)
{
}

void P8_DebugExpandline(unsigned char line, unsigned char *data)
{
}

