#ifndef ROM_H
#define ROM_H

typedef struct _rominfo
{
    char name[128];
    char *filename;
    char *sramname;    
    int prg_pages;
    int chr_pages;
    union
    {
	struct _rflags
	{
	    unsigned mirror : 1;
	    unsigned sram   : 1;
	    unsigned trainer: 1;
	    unsigned vram   : 1;
	} f;
	unsigned char b;
    } f;
    int mapper;
    unsigned char *trainer;
    unsigned char *prgrom;
    unsigned char *chrrom;
    unsigned char *sram;
    unsigned short initaddr;
    unsigned short playaddr;
    unsigned short loadaddr;
    unsigned char switchinit[8];
    unsigned char nsf;
    unsigned short pbrate;
    unsigned char maxsongs;
    unsigned char startsong;
} rominfo;

rominfo *loadrom(char *fname);

#endif
