#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "rom.h"

int main(int argc, char **argv)
{
    rominfo *ri;
    int i;
    FILE *fp;
    unsigned char header[16];    
    char romname[255];
    char hdrname[255];
    char trnname[255];
    char prgname[255];
    char chrname[255];
    char namname[255];
    
    if (argc < 2)
	return 0;
    
    strcpy(romname, argv[1]);
    strcpy(hdrname, romname);
    strcpy(trnname, romname);
    strcpy(prgname, romname);
    strcpy(chrname, romname);
    strcpy(namname, romname);
	    
    strcat(romname, ".nes");
    strcat(hdrname, ".hdr");
    strcat(trnname, ".trn");
    strcat(prgname, ".prg");
    strcat(chrname, ".chr");
    strcat(namname, ".nam");

    ri = loadrom(romname);

    header[0] = 'N';
    header[1] = 'E';
    header[2] = 'S';
    header[3] = '\032';
    header[4] = ri->prg_pages;
    header[5] = ri->chr_pages;
    header[6] = ri->f.b | ((ri->mapper&0x0F) << 4);
    header[7] = ri->mapper & 0xF0;
    header[8] = 0;
    header[9] = 0;
    header[10] = 0;
    header[11] = 0;
    header[12] = 0;
    header[13] = 0;
    header[14] = 0;
    header[15] = 0;

    fp = fopen(hdrname, "wb");
    fwrite(header, 16, 1, fp);
    fclose(fp);

    fp = fopen(trnname, "wb");
    if (ri->f.f.trainer)
	fwrite(ri->trainer, 512, 1, fp);
    fclose(fp);

    fp = fopen(prgname, "wb");
    
    for (i = 0; i < ri->prg_pages; i++)
	fwrite(ri->prgrom[i], 0x4000, 1, fp);
    fclose(fp);
    
    fp = fopen(chrname, "wb");
    
    for (i = 0; i < ri->chr_pages; i++)
	fwrite(ri->chrrom[i], 0x2000, 1, fp);
    fclose(fp);
    
    fp = fopen(namname, "wb");
    fwrite(ri->name, 128, 1, fp);
    fclose(fp);

    return 0;
}
