#include <stdio.h>

#include <X11/X.h>
#include <X11/Xlib.h>

#include "xlibgfx.h"
#include "t16.h"
#include "pal.h"

extern unsigned char *framebuffer;
extern unsigned short *debugbuffer;
unsigned short palconv[69];
unsigned short black, red, blue, green;
unsigned short pallut[32];

void T16_InitLookups(void)
{
    XColor col;
    int i;

    printf("Initializing lookups\n");
    xcmap = XCreateColormap(xdisp, xwin, xvisual, 0);

    col.flags = DoRed | DoGreen | DoBlue;
    col.red = 0;
    col.green = 0;
    col.blue = 0;
    XAllocColor(xdisp, xcmap, &col);
    black = col.pixel;
    col.flags = DoRed | DoGreen | DoBlue;
    col.red = 0xFFFF;
    col.green = 0;
    col.blue = 0;
    XAllocColor(xdisp, xcmap, &col);
    red = col.pixel;
    col.flags = DoRed | DoGreen | DoBlue;
    col.red = 0;
    col.green = 0xFFFF;
    col.blue = 0;
    XAllocColor(xdisp, xcmap, &col);
    green = col.pixel;
    col.flags = DoRed | DoGreen | DoBlue;
    col.red = 0;
    col.green = 0;
    col.blue = 0xFFFF;
    XAllocColor(xdisp, xcmap, &col);
    blue= col.pixel;

    for (i = 0; i < 64; i++)
    {
	col.flags = DoRed | DoGreen | DoBlue;
	col.red = nes_pal[i].r;
	col.green = nes_pal[i].g;
	col.blue = nes_pal[i].b;
	col.red += col.red << 8;
	col.green += col.green << 8;
	col.blue += col.blue << 8;
	if (XAllocColor(xdisp, xcmap, &col))
	{
	    palconv[i] = col.pixel;
	}
    }
    palconv[64] = black;
    palconv[65] = red;
    palconv[66] = green;
    palconv[68] = blue;
}

void T16_Expandline(unsigned char line, unsigned char *data)
{
    int i;
    unsigned short *buf = (unsigned short *)framebuffer + (line << 8);
    
    for (i = 0; i < 256; i++)
	buf[i] = pallut[data[i]];
}

void T16_Clearline(unsigned char line)
{
}

void T16_Updatepal(unsigned char *data)
{
    unsigned short *p = pallut;
    
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];

    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];

    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];

    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p++ = palconv[*data++];
    *p = palconv[*data];    
}

void T16_DebugExpandline(unsigned char line, unsigned char *data)
{
/*    int i;
    unsigned short *buf = debugbuffer;
    buf += (line << 8);
    
    for (i = 0; i < 256; i++)
    {
	switch (data[i])
	{
	case 0xF0: buf[i] = black; break;
	case 0xF1: buf[i] = red; break;
	case 0xF2: buf[i] = blue; break;
	case 0xF4: buf[i] = green; break;
	default: buf[i] = palconv[data[i]];
	}
	}*/
}
