#include "t6502.h"
#include <time.h>

CPU_6502_unit myCPU;
BYTE RAM[0xFFFF];
FILE *f;
int n=0;
clock_t start, end;
double elapsed;

BYTE my_read_mem(register WORD A) {
 return RAM[A];
}

BYTE my_read_op(register WORD A) {
 return RAM[A];
}

void my_write_mem(register BYTE D,register WORD A) {
 RAM[A] = D;
 
 switch(A) {
  case 0x7FFF:  printf("\nPort $7fff write-> $%02X\n",D);
  printf("A: $%02X, X: $%02X, Y: $%02X, S: $%02X, PC: $%04X, P: $%02X\n",
      myCPU.A, myCPU.X, myCPU.Y, myCPU.S, myCPU.PC.word, myCPU.status);
  }
}

int main(void) {
 FILE *f;

 f = fopen("test.rom", "rb");
 printf("Opened file\n");
 fread(&RAM[0x8000],32768,1,f);
 printf("read file\n");

 fclose(f);
 printf("closed file\n");

 t6502_init_emu();
 printf("init done\n");

 t6502_init_cpu(&myCPU, my_read_mem, my_read_op, my_write_mem);
  
 printf("reset done\n");
 start = clock();

/*  while(myCPU.cycles < 100000000) { */
  t6502_run(&myCPU,30);
  myCPU.cycles = 0;
  t6502_trigger_NMI(&myCPU);
  t6502_run(&myCPU,99999970); 
/*  if (CPU.cycles & 0xF0000)
  printf("\rPC=$%04X, Cycles=%d, inst: %d",CPU.PC.word, CPU.cycles, n); */
/*  n++; */
/* } */
 end = clock();
 elapsed = ((double) (end - start)) / CLOCKS_PER_SEC;

 printf("Time elapsed: %3.4f seconds, MHZ=%3.7f\n",elapsed,(double)100/elapsed);
}
