#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include <stdio.h>

#include "xlibgfx.h"
#include "xlibio.h"

#include "apu.h"

#include "io.h"

extern int quitemu;
extern unsigned char fxduty;
extern unsigned char cursong;
extern unsigned char dumptables;

unsigned char changesong = 0;

void init_XIO(void)
{
}

unsigned char Read_PPU(unsigned short);
extern unsigned char *nt1;
extern unsigned char *vrom;
extern unsigned char SPR_ram[0x100];
unsigned char showcache = 0;

void Dumpstuff(void)
{
    unsigned char pal[16];
    FILE *fp;
    int i;

    printf("Reading pallete\n");
    for (i = 0; i < 16; i++)
	pal[i] = Read_PPU(0x3F10 + i);
    
/*    fp = fopen("test.pal2", "wb");
    printf("Writing pallete\n");
    if (!fp)
	printf("can't open test.pal2");
    fwrite(pal, 1, 16, fp);
    fclose(fp);*/

    fp = fopen("test.gfx", "wb");
    fwrite(nt1, 1, 0x3C0, fp);
    fclose(fp);
    printf("done\n");
}

void Process_IO(unsigned char block)
{
    while (block || XPending(xdisp))
    {
	int key;
	XEvent event;
	XNextEvent(xdisp, &event);
	key = XKeycodeToKeysym(xdisp, event.xkey.keycode, 0);
	block = 0;

	switch (event.type)
	{
	case KeyPress:
	    switch (key)
	    {
	    case XK_Escape:
		quitemu = 1;
		break;
	    case XK_1:
		enable_pulse1 ^= 1;
		break;
	    case XK_2:
		enable_pulse2 ^= 1;
		break;
	    case XK_3:
		enable_tri ^= 1;
		break;
	    case XK_4:
		enable_noise ^= 1;
		break;
	    case XK_5:
		enable_pcm ^= 1;
		break;
	    case XK_S:
	    case XK_s:
		showcache ^= 1;
		break;
	    case XK_D:
	    case XK_d:
		dumptables = 1;
		return;
	    case XK_F1:
		printf("Dumping gfx\n");
		Dumpstuff();
		break;
	    case XK_Up:
	    case XK_KP_Up:
		port1data[0] |= IOMASK_UP;
		break;
	    case XK_Down:
	    case XK_KP_Down:
		port1data[0] |= IOMASK_DOWN;
		break;
	    case XK_Left:
	    case XK_KP_Left:
		port1data[0] |= IOMASK_LEFT;
		break;
	    case XK_Right:
	    case XK_KP_Right:
		port1data[0] |= IOMASK_RIGHT;
		break;
	    case XK_Z:
	    case XK_z:
		port1data[0] |= IOMASK_B;
		break;
	    case XK_X:
	    case XK_x:
		port1data[0] |= IOMASK_A;
		break;
	    case XK_Return:
		port1data[0] |= IOMASK_START;
		break;
	    case XK_Shift_R:
		port1data[0] |= IOMASK_SELECT;
		break;
	    case XK_A:
	    case XK_a:
		break;
	    }
	    break;
	case KeyRelease:
	    switch (key)
	    {
	    case XK_Up:
	    case XK_KP_Up:
		port1data[0] &= ~IOMASK_UP;
		break;
	    case XK_Down:
	    case XK_KP_Down:
		port1data[0] &= ~IOMASK_DOWN;
		break;
	    case XK_Left:
	    case XK_KP_Left:
		port1data[0] &= ~IOMASK_LEFT;
		break;
	    case XK_Right:
	    case XK_KP_Right:
		port1data[0] &= ~IOMASK_RIGHT;
		break;
	    case XK_Z:
	    case XK_z:
		port1data[0] &= ~IOMASK_B;
		break;
	    case XK_X:
	    case XK_x:
		port1data[0] &= ~IOMASK_A;
		break;
	    case XK_Return:
		cursong++;
		changesong++;
		port1data[0] &= ~IOMASK_START;
		break;
	    case XK_Shift_R:
		port1data[0] &= ~IOMASK_SELECT;
		break;
	    }
	    break;
	}
    }
}


